VTK: vtkImplicitPolyDataDistance Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkImplicitPolyDataDistance Class Reference

Implicit function that computes the distance from a point x to the nearest point p on an input vtkPolyData. More...

`#include <vtkImplicitPolyDataDistance.h>`

Inheritance diagram for vtkImplicitPolyDataDistance:
[legend]
Collaboration diagram for vtkImplicitPolyDataDistance:
[legend]

## Public Types
typedef vtkImplicitFunction | Superclass
Public Types inherited from vtkImplicitFunction
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkImplicitPolyDataDistance * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkMTimeType | GetMTime () override
| Return the MTime also considering the Input dependency. More...
double | EvaluateFunction (double x[3]) override
| Evaluate function at position x-y-z and return value. More...
void | EvaluateGradient (double x[3], double g[3]) override
| Evaluate function gradient of nearest triangle to point x[3]. More...
double | EvaluateFunctionAndGetClosestPoint (double x[3], double closestPoint[3])
| Evaluate plane equation of nearest triangle to point x[3] and provides closest point on an input vtkPolyData. More...
void | SetInput (vtkPolyData *input)
| Set the input vtkPolyData used for the implicit function evaluation. More...
virtual double | EvaluateFunction (double x[3])=0
| Evaluate plane equation of nearest triangle to point x[3]. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate plane equation of nearest triangle to point x[3]. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate plane equation of nearest triangle to point x[3]. More...
virtual void | SetNoValue (double)
| Set/get the function value to use if no input vtkPolyData specified. More...
virtual double | GetNoValue ()
| Set/get the function value to use if no input vtkPolyData specified. More...
virtual void | SetNoGradient (double, double, double)
| Set/get the function gradient to use if no input vtkPolyData specified. More...
virtual void | SetNoGradient (double[3])
| Set/get the function gradient to use if no input vtkPolyData specified. More...
virtual double * | GetNoGradient ()
| Set/get the function gradient to use if no input vtkPolyData specified. More...
virtual void | GetNoGradient (double &, double &, double &)
| Set/get the function gradient to use if no input vtkPolyData specified. More...
virtual void | GetNoGradient (double[3])
| Set/get the function gradient to use if no input vtkPolyData specified. More...
virtual void | SetNoClosestPoint (double, double, double)
| Set/get the closest point to use if no input vtkPolyData specified. More...
virtual void | SetNoClosestPoint (double[3])
| Set/get the closest point to use if no input vtkPolyData specified. More...
virtual double * | GetNoClosestPoint ()
| Set/get the closest point to use if no input vtkPolyData specified. More...
virtual void | GetNoClosestPoint (double &, double &, double &)
| Set/get the closest point to use if no input vtkPolyData specified. More...
virtual void | GetNoClosestPoint (double[3])
| Set/get the closest point to use if no input vtkPolyData specified. More...
virtual double | GetTolerance ()
| Set/get the tolerance used for the locator. More...
virtual void | SetTolerance (double)
| Set/get the tolerance used for the locator. More...
Public Member Functions inherited from vtkImplicitFunction
vtkImplicitFunction * | NewInstance () const
virtual void | FunctionValue (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (const double x[3])
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (double x, double y, double z)
| Evaluate function at position x-y-z and return value. More...
void | FunctionGradient (const double x[3], double g[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (const double x[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (double x, double y, double z)
| Evaluate function gradient at position x-y-z and pass back vector. More...
virtual void | SetTransform (vtkAbstractTransform *)
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | SetTransform (const double elements[16])
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual vtkAbstractTransform * | GetTransform ()
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate function at position x-y-z and return value. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkImplicitPolyDataDistance * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitPolyDataDistance * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkImplicitFunction
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitFunction * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkImplicitPolyDataDistance ()
| ~vtkImplicitPolyDataDistance () override
void | CreateDefaultLocator ()
| Create default locator. More...
double | SharedEvaluate (double x[3], double g[3], double closestPoint[3])
Protected Member Functions inherited from vtkImplicitFunction
| vtkImplicitFunction ()
| ~vtkImplicitFunction () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | NoGradient [3]
double | NoClosestPoint [3]
double | NoValue
double | Tolerance
vtkPolyData * | Input
vtkCellLocator * | Locator
vtkSMPThreadLocalObject< vtkGenericCell > | TLCell
vtkSMPThreadLocalObject< vtkIdList > | TLCellIds
Protected Attributes inherited from vtkImplicitFunction
vtkAbstractTransform * | Transform
double | ReturnValue [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Implicit function that computes the distance from a point x to the nearest point p on an input vtkPolyData.

Implicit function that computes the distance from a point x to the nearest point p on an input vtkPolyData. The sign of the function is set to the sign of the dot product between the angle-weighted pseudonormal at the nearest surface point and the vector x - p. Points interior to the geometry have a negative distance, points on the exterior have a positive distance, and points on the input vtkPolyData have a distance of zero. The gradient of the function is the angle-weighted pseudonormal at the nearest point.

Baerentzen, J. A. and Aanaes, H. (2005). Signed distance computation using the angle weighted pseudonormal. IEEE Transactions on Visualization and Computer Graphics, 11:243-253.

This code was contributed in the VTK Journal paper: "Boolean Operations on Surfaces in VTK Without External Libraries" by Cory Quammen, Chris Weigle C., Russ Taylor http://hdl.handle.net/10380/3262 http://www.midasjournal.org/browse/publication/797

Online Examples:

Tests:
  vtkImplicitPolyDataDistance (Tests)

Definition at line 52 of file vtkImplicitPolyDataDistance.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkImplicitFunction vtkImplicitPolyDataDistance::Superclass

Definition at line 56 of file vtkImplicitPolyDataDistance.h.

## Constructor & Destructor Documentation

## ◆ vtkImplicitPolyDataDistance()

vtkImplicitPolyDataDistance::vtkImplicitPolyDataDistance | ( |  | ) |
| protected

## ◆ ~vtkImplicitPolyDataDistance()

vtkImplicitPolyDataDistance::~vtkImplicitPolyDataDistance | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkImplicitPolyDataDistance* vtkImplicitPolyDataDistance::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkImplicitPolyDataDistance::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkImplicitPolyDataDistance::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkImplicitFunction.

## ◆ SafeDownCast()

static vtkImplicitPolyDataDistance* vtkImplicitPolyDataDistance::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkImplicitPolyDataDistance::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkImplicitFunction.

## ◆ NewInstance()

vtkImplicitPolyDataDistance* vtkImplicitPolyDataDistance::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkImplicitPolyDataDistance::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkImplicitFunction.

## ◆ GetMTime()

vtkMTimeType vtkImplicitPolyDataDistance::GetMTime | ( |  | ) |
| overridevirtual

Return the MTime also considering the Input dependency.

Reimplemented from vtkImplicitFunction.

## ◆ EvaluateFunction() [1/4]

double vtkImplicitPolyDataDistance::EvaluateFunction | ( | double | x[3] | ) |
| overridevirtual

Evaluate function at position x-y-z and return value.

You should generally not call this method directly, you should use FunctionValue() instead. This method must be implemented by any derived class.

Implements vtkImplicitFunction.

## ◆ EvaluateGradient()

void vtkImplicitPolyDataDistance::EvaluateGradient | ( | double | x[3],
|  | double | g[3]
| ) |  |
| overridevirtual

Evaluate function gradient of nearest triangle to point x[3].

Implements vtkImplicitFunction.

## ◆ EvaluateFunctionAndGetClosestPoint()

double vtkImplicitPolyDataDistance::EvaluateFunctionAndGetClosestPoint | ( | double | x[3],
|  | double | closestPoint[3]
| ) |  |

Evaluate plane equation of nearest triangle to point x[3] and provides closest point on an input vtkPolyData.

## ◆ SetInput()

void vtkImplicitPolyDataDistance::SetInput | ( | vtkPolyData * | input | ) |

Set the input vtkPolyData used for the implicit function evaluation.

Passes input through an internal instance of vtkTriangleFilter to remove vertices and lines, leaving only triangular polygons for evaluation as implicit planes.

## ◆ SetNoValue()

virtual void vtkImplicitPolyDataDistance::SetNoValue | ( | double |  | ) |
| virtual

Set/get the function value to use if no input vtkPolyData specified.

## ◆ GetNoValue()

virtual double vtkImplicitPolyDataDistance::GetNoValue | ( |  | ) |
| virtual

Set/get the function value to use if no input vtkPolyData specified.

## ◆ SetNoGradient() [1/2]

virtual void vtkImplicitPolyDataDistance::SetNoGradient | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/get the function gradient to use if no input vtkPolyData specified.

## ◆ SetNoGradient() [2/2]

virtual void vtkImplicitPolyDataDistance::SetNoGradient | ( | double | [3] | ) |
| virtual

Set/get the function gradient to use if no input vtkPolyData specified.

## ◆ GetNoGradient() [1/3]

virtual double* vtkImplicitPolyDataDistance::GetNoGradient | ( |  | ) |
| virtual

Set/get the function gradient to use if no input vtkPolyData specified.

## ◆ GetNoGradient() [2/3]

virtual void vtkImplicitPolyDataDistance::GetNoGradient | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/get the function gradient to use if no input vtkPolyData specified.

## ◆ GetNoGradient() [3/3]

virtual void vtkImplicitPolyDataDistance::GetNoGradient | ( | double | [3] | ) |
| virtual

Set/get the function gradient to use if no input vtkPolyData specified.

## ◆ SetNoClosestPoint() [1/2]

virtual void vtkImplicitPolyDataDistance::SetNoClosestPoint | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/get the closest point to use if no input vtkPolyData specified.

## ◆ SetNoClosestPoint() [2/2]

virtual void vtkImplicitPolyDataDistance::SetNoClosestPoint | ( | double | [3] | ) |
| virtual

Set/get the closest point to use if no input vtkPolyData specified.

## ◆ GetNoClosestPoint() [1/3]

virtual double* vtkImplicitPolyDataDistance::GetNoClosestPoint | ( |  | ) |
| virtual

Set/get the closest point to use if no input vtkPolyData specified.

## ◆ GetNoClosestPoint() [2/3]

virtual void vtkImplicitPolyDataDistance::GetNoClosestPoint | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/get the closest point to use if no input vtkPolyData specified.

## ◆ GetNoClosestPoint() [3/3]

virtual void vtkImplicitPolyDataDistance::GetNoClosestPoint | ( | double | [3] | ) |
| virtual

Set/get the closest point to use if no input vtkPolyData specified.

## ◆ GetTolerance()

virtual double vtkImplicitPolyDataDistance::GetTolerance | ( |  | ) |
| virtual

Set/get the tolerance used for the locator.

## ◆ SetTolerance()

virtual void vtkImplicitPolyDataDistance::SetTolerance | ( | double |  | ) |
| virtual

Set/get the tolerance used for the locator.

## ◆ CreateDefaultLocator()

void vtkImplicitPolyDataDistance::CreateDefaultLocator | ( |  | ) |
| protected

Create default locator.

Used to create one when none is specified.

## ◆ SharedEvaluate()

double vtkImplicitPolyDataDistance::SharedEvaluate | ( | double | x[3],
|  | double | g[3],
|  | double | closestPoint[3]
| ) |  |
| protected

## ◆ EvaluateFunction() [2/4]

virtual double vtkImplicitFunction::EvaluateFunction

Evaluate plane equation of nearest triangle to point x[3].

## ◆ EvaluateFunction() [3/4]

virtual void vtkImplicitFunction::EvaluateFunction

Evaluate plane equation of nearest triangle to point x[3].

## ◆ EvaluateFunction() [4/4]

virtual double vtkImplicitFunction::EvaluateFunction
| inline

Evaluate plane equation of nearest triangle to point x[3].

Definition at line 121 of file vtkImplicitFunction.h.

## Member Data Documentation

## ◆ NoGradient

double vtkImplicitPolyDataDistance::NoGradient[3]
| protected

Definition at line 135 of file vtkImplicitPolyDataDistance.h.

## ◆ NoClosestPoint

double vtkImplicitPolyDataDistance::NoClosestPoint[3]
| protected

Definition at line 136 of file vtkImplicitPolyDataDistance.h.

## ◆ NoValue

double vtkImplicitPolyDataDistance::NoValue
| protected

Definition at line 137 of file vtkImplicitPolyDataDistance.h.

## ◆ Tolerance

double vtkImplicitPolyDataDistance::Tolerance
| protected

Definition at line 138 of file vtkImplicitPolyDataDistance.h.

## ◆ Input

vtkPolyData* vtkImplicitPolyDataDistance::Input
| protected

Definition at line 140 of file vtkImplicitPolyDataDistance.h.

## ◆ Locator

vtkCellLocator* vtkImplicitPolyDataDistance::Locator
| protected

Definition at line 141 of file vtkImplicitPolyDataDistance.h.

## ◆ TLCell

vtkSMPThreadLocalObject<vtkGenericCell> vtkImplicitPolyDataDistance::TLCell
| protected

Definition at line 142 of file vtkImplicitPolyDataDistance.h.

## ◆ TLCellIds

vtkSMPThreadLocalObject<vtkIdList> vtkImplicitPolyDataDistance::TLCellIds
| protected

Definition at line 143 of file vtkImplicitPolyDataDistance.h.

The documentation for this class was generated from the following file:

- Filters/Core/vtkImplicitPolyDataDistance.h